package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysRefExpressionTrigger;
import cn.estsh.i3plus.pojo.platform.bean.SysTaskTimeExpression;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 定时任务表达式业务接口
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.771
 * @Modify      :
 **/
public interface ISysTaskTimeExpressionService {

    /**
     * 修改数据
     * @param taskTimeExpression
     */
    @ApiOperation(value = "修改数据")
    void updateSysTaskTimeExpression(SysTaskTimeExpression taskTimeExpression);

    /**
     * 根据id删除数据
     * @param id
     */
    @ApiOperation(value = "根据id删除数据")
    void deleteSysTaskTimeExpressionById(Long id);

    /**
     * 新增数据
     * @param taskTimeExpression
     * @return
     */
    @ApiOperation(value = "新增数据")
    SysTaskTimeExpression insertSysTaskTimeExpression(SysTaskTimeExpression taskTimeExpression);

    /**
     * 查询所有数据
     * @return
     */
    @ApiOperation(value = "查询所有数据")
    List<SysTaskTimeExpression> listSysTaskTimeExpression();

    /**
     * 根据ID 查询任务表达式
     * @param id
     * @return
     */
    @ApiOperation(value = "根据ID 查询任务表达式")
    SysTaskTimeExpression getSysTaskTimeExpressionById(Long id);

    /**
     * 任务表达式查询，分页，排序
     * @param taskTimeExpression
     * @param pager
     * @return
     */
    @ApiOperation(value = "任务表达式查询，分页，排序")
    ListPager querySysTaskTimeExpressionByPager(SysTaskTimeExpression taskTimeExpression, Pager pager);

    /**
     * 任务表达式批量删除
     * @param ids
     */
    @ApiOperation(value = "任务表达式批量删除")
    void deleteSysTaskTimeExpressionByIds(Long[] ids);

    /**
     * 查询表达式所关联的定时任务信息
     * @return
     */
    @ApiOperation(value = "根据表达式id查询表达式关联任务信息",notes = "根据表达式id查询表达式关联任务信息")
    List<SysRefExpressionTrigger> findRefExpressionTriggerList(Long id);
}
